open Types

let convert c =
  match c with
    'I' -> I | 'C' -> C | 'F' -> F | 'P' -> P 
  | c -> raise End_of_file


let rec read tab n cin =
  for i = 0 to n - 1  do
    tab.(i) <- convert (input_char cin)
  done;
  tab
  
let step = int_of_string (Sys.argv.(1))
let prefix = Sys.argv.(2)

let () =
  Build.reset ();
  let cin = open_in prefix in
  let tab = Array.create 7 I in
  let cpt = ref 0 in
  begin try
    while true do
      let v = read tab 7 cin in
      cpt := (!cpt + 1) mod step;
      ignore (Build.exec (!cpt = 0) v)
    done
  with
      End_of_file -> ()
  end;
  Build.draw_top ~force:true ();
  Build.dump_state ();
  Format.printf "Press any key to finish@.";
  ignore (Graphics.wait_next_event [Graphics.Key_pressed])

