
module type STRING = sig
  type t 
  type char
  val length : t -> int
  val get : t -> int -> char
end

module Make(T : STRING)(P : STRING with type char = T.char) = struct

  let search t p =
    let n = T.length t in
    let m = P.length p in
    let next = Array.create m 0 in
    (* initialization of [next] *)
    let i = ref 1 in
    let j = ref 0 in
    if m > 1 then begin
      while !i < m - 1 do
	if P.get p !i = P.get p !j then begin
	  i := !i + 1; j:= !j + 1; next.(!i) <- !j
	end else
	  if !j = 0 then i := !i + 1 (* next[i] <- 0 *) else j := next.(!j)
      done
    end;
    (* search in [t] *)
    i := 0;
    j := 0;
    while !j < m && !i < n do
      if T.get t !i = P.get p !j then begin
	i := !i + 1; j:= !j + 1
      end else
	if !j = 0 then i := !i + 1 else j := next.(!j)
    done;
    if !j = m then !i - m else raise Not_found

end
