
open Types
exception Dumpstack

let base_of_char = function
  | 'I' -> I
  | 'C' -> C
  | 'F' -> F
  | 'P' -> P
  | c -> Format.printf "Invalid char:'%x'@." (Char.code c);assert false

let char_of_base = function
  | I -> 'I'
  | C -> 'C'
  | F -> 'F'
  | P -> 'P'

let baselist_of_string s =
  let rec loop acc i = 
    if i < 0 then acc else loop (base_of_char s.[i] :: acc) (i-1) 
  in
  loop [] (String.length s - 1)

let print_base fmt b =
  Format.fprintf fmt "%c" (char_of_base b)

let print_rna7 fmt a = 
  Array.iter (fun x -> print_base fmt x) a

let filter_dna prefix =
  let ch = open_in prefix in
  let buf = Buffer.create 17 in
  try
    while true do
      let c = input_char ch in
      match c with
	| 'I' | 'C' | 'F' | 'P' -> Buffer.add_char buf c
	| '#' -> raise Exit
	| _ -> ()
    done;
    assert false
  with Exit | End_of_file -> Buffer.contents buf
  
