module T = struct
  type t = in_channel * char ref * int ref 
  let length t = Pervasives.max_int
  type char' = char
  type char = char'
  let get t i = 
    let (ch,last,n) = t in
    if i = !n-1 then !last else
      if i = !n then
	try
	  let c = input_char ch in
	  last := c;
	  incr n;
	  c
	with End_of_file -> raise Not_found
      else assert false
end

module P = struct
  type t = string
  let length = String.length
  type char' = char
  type char = char'
  let get = String.get
end

module KnuthMorrisPratt = Kmp.Make(T)(P)

let pat = Sys.argv.(1)

let () =
  let ch = open_in "endo.dna" in
  let o = ref 0 in
  try
    while true do
      let i = KnuthMorrisPratt.search (ch,ref ' ',ref 0) pat in
      o := !o + i;
      Format.printf "Found at i=%d (%x)@." !o !o
    done;
  with Not_found -> Format.printf "Not found@."

