
type dir = E | N | W | S

type command = 
  | Black 
  | Red
  | Green
  | Yellow
  | Blue 
  | Magenta
  | Cyan 
  | White
  | Transparent
  | Opaque
  | EmptyBucket
  | Move
  | TCC
  | TC 
  | Mark
  | Line
  | TryFill
  | AddBitmap
  | Compose
  | Clip

open Format

let channel = ref stdout
let fmt = ref Format.std_formatter

let new_formatter f =
  let ch = open_out f in
  channel := ch;
  fmt := Format.formatter_of_out_channel ch
    
let close_formatter () =
  Format.pp_print_flush !fmt ();
  close_out !channel;
  channel := stdout;
  fmt := Format.std_formatter

let output c =
  let printf = fprintf !fmt in
  printf "III";
  match c with
  | Black -> printf "PIPIIIC"
  | Red -> printf "PIPIIIP"
  | Green -> printf "PIPIICC"
  | Yellow -> printf "PIPIICF"
  | Blue -> printf "PIPIICP"
  | Magenta -> printf "PIPIIFC"
  | Cyan -> printf "PIPIIFF"
  | White -> printf "PIPIIPC"
  | Transparent -> printf "PIPIIPF"
  | Opaque -> printf "PIPIIPP"
  | EmptyBucket -> printf "PIIPICP"
  | Move -> printf "PIIIIIP"
  | TCC -> printf "PCCCCCP"
  | TC -> printf "PFFFFFP"
  | Mark -> printf "PCCIFFP"
  | Line -> printf "PFFICCP"
  | TryFill -> printf "PIIPIIP"
  | AddBitmap -> printf "PCCPFFP"
  | Compose -> printf "PFFPCCP"
  | Clip -> printf "PFFICCF"
      
(* marche pas...
let make_color red green blue =
  let r = ref 0 and g = ref 0 and b = ref 0 in
  let l = ref [] and n = ref 0 in
  let add_color c rr gg bb =
    l := c :: !l;
    incr n;
    r := !r + rr;
    g := !g + gg;
    b := !b + bb
  in
  while (!n == 0 
	 || !r / !n <> red 
	 || !g / !n <> green 
	 || !b / !n <> blue) do
    if !r < red then
      if !g < green then
	if !b < blue then
	  add_color White 255 255 255
	else	  
	  add_color Yellow 255 255 0
      else
	if !b < blue then
	  add_color Magenta 255 0 255
	else	  
	  add_color Red 255 0 0
    else
      if !g < green then
	if !b < blue then
	  add_color Cyan 0 255 255
	else	  
	  add_color Green 0 255 0
      else
	if !b < blue then
	  add_color Blue 0 0 255
	else	  
	  add_color Black 0 0 0
  done;
  !l
;;

*)

let make_color red green blue =
  let r = ref 0 and g = ref 0 and b = ref 0 in
  let l = ref [] in
  let add_color c rr gg bb =
    l := c :: !l;
    r := !r + rr;
    g := !g + gg;
    b := !b + bb
  in
  for i=1 to 255 do
    if !r < red then
      if !g < green then
	if !b < blue then
	  add_color White 1 1 1
	else	  
	  add_color Yellow 1 1 0
      else
	if !b < blue then
	  add_color Magenta 1 0 1
	else	  
	  add_color Red 1 0 0
    else
      if !g < green then
	if !b < blue then
	  add_color Cyan 0 1 1
	else	  
	  add_color Green 0 1 0
      else
	if !b < blue then
	  add_color Blue 0 0 1
	else	  
	  add_color Black 0 0 0
  done;
  !l
;;

(*
make_color 0 0 0;;
make_color 255 255 255;;
make_color 127 127 127;;
make_color 85 170 85;;
make_color 23 209 255;;
*)

let select_color r g b =
  output EmptyBucket;
  List.iter output (make_color r g b)

let xx = ref 0 
let yy = ref 0
let dd = ref E

let reset() =
  xx := 0;
  yy := 0;
  dd := E

let mark () = output Mark
let line () = output Line
let tryfill () = output TryFill
let move () =
  output Move;
  match !dd with
    | E -> incr xx;
    | N -> decr yy;
    | W -> decr xx;
    | S -> incr yy
let tcc () =
  output TCC;
  dd :=
    match !dd with
      | E -> N
      | N -> W
      | W -> S
      | S -> E
let tc () =
  output TC;
  dd :=
    match !dd with
      | E -> S
      | N -> E
      | W -> N
      | S -> W


let rec moveto x y =
  if x = !xx && y = !yy then () else
  match !dd with
    | E -> 
	if x > !xx then (move (); moveto x y) else
	  if y < !yy then (tcc ();  moveto x y) else
	    (tc ();  moveto x y)
    | N -> 
	if y < !yy then (move (); moveto x y) else
	  if x < !xx then (tcc ();  moveto x y) else
	    (tc ();  moveto x y)
    | W -> 
	if x < !xx then (move (); moveto x y) else
	  if y > !yy then (tcc ();  moveto x y) else
	    (tc ();  moveto x y)
    | S -> 
	if y > !yy then (move (); moveto x y) else
	  if x > !xx then (tcc ();  moveto x y) else
	    (tc ();  moveto x y)

(* assume x1 < x2 et y1 < y2 ET interieur monocolore ! *)
let fill_rectangle x1 y1 x2 y2 =
  moveto x1 y1;
  mark ();
  moveto x2 y1;
  line ();
  mark ();
  moveto x2 y2;
  line ();
  mark ();
  moveto x1 y2;
  line ();
  mark ();
  moveto x1 y1;
  line ();
  moveto (x1+1) (y1+1);
 tryfill() 

;;

let rec output_nat n =
  if n=0 then fprintf !fmt "P" (* zero *)
  else
    begin
      if n mod 2 = 0 then fprintf !fmt "I" (* pair *)
      else fprintf !fmt "C" (* impair *);
      output_nat (n/2)
    end

type pat =
    | Skip of int
    | Left
    | Right

let output_pat p =
  match p with
    | Skip n ->
	fprintf !fmt "IP"; (* pattern '!' *)
	output_nat n
    | Left ->
	fprintf !fmt "IIP"; (* pattern '(' *)
    | Right ->
	fprintf !fmt "IIC"; (* pattern ')' *)

type tpl =
  | Index of int * int  
  | Command of command

let output_tpl t = 
  match t with 
    | Index(n,l) ->
	fprintf !fmt "IP"; 
	output_nat l;
	output_nat n
    | Command c -> 
	fprintf !fmt "III";
	output c

let matchreplace pat tpl =
  List.iter output_pat pat;
  fprintf !fmt "IIF"; (* separateur *)
  List.iter output_tpl tpl;
  fprintf !fmt "IIF"; (* separateur *)
  ()
  
let () = 
  reset();
  new_formatter "essai2.dna";
(*
  select_color 23 209 255;
  fill_rectangle 0 0 599 239;
*)
  select_color 212 246 255;
  fill_rectangle 354 42 455 96;
  moveto 0 0;
  tc();
(*
  select_color 0 100 0;
  fill_rectangle 0 240 599 5999;
*)
  matchreplace [Left ; Skip 7523060 ; Right] [ (* Index(0,0) ; Command Compose *) ];
  close_formatter ()

;;


