
open Types

type t  

val empty : t

val create : string -> string -> t

val of_string : string -> t

val len : t -> int

(* raises [Not_found] if nothing to pop *)
val pop : t -> base * t

(* raises [Not_found] if out of range *)
val get : t -> int -> base

val skip : t -> int -> t

val append : t -> t -> t

(* returns t[start..stop], stop NOT INCLUDED
   if stop too large, the maximum suffix is returned
   see page 3-4
 *)
val sub : t -> int -> int -> t

(* raises [Not_found] if no occurrence *)
val search_forward : t -> int -> base list -> int

val of_list : base list -> t
val to_list : t -> base list
val base : base -> t

val print : Format.formatter -> t -> unit
val print_start : int -> Format.formatter -> t -> unit
