
open Types

type t  

val create : prefix:string -> dna:string -> t

val of_string : string -> t

val len : t -> int

(* raises [Not_found] if nothing to pop *)
val pop : t -> base * t

(* raises [Not_found] if out of range *)
val get : t -> i:int -> base

val skip : t -> i:int -> t

val push : base list -> t -> t

(* returns t[start..stop], stop NOT INCLUDED
   if stop too large, the maximum suffix is returned
   see page 3-4
 *)
val sub : t -> start:int -> stop:int -> base list

(* raises [Not_found] if no occurrence *)
val search_forward : t -> i:int -> s:base list -> int

