
open Types
open Misc
open Format
open Dna

let dna = create ~prefix:"selfcheck.dna" ~dna:"endo.dna"

let rec print_list fmt = function
  | [] -> ()
  | b :: l -> fprintf fmt "%a%a" print_base b print_list l

let test_sub t start stop =
  let l = sub t start stop in
  for i = 0 to stop-start-1 do
    assert (get t (start+i) = get l i)
  done;
  l

let compare_sub dna dna' start stop =
  let l = test_sub dna start stop in
  let l' = test_sub dna' start stop in
  assert (to_list l = to_list l');
  printf "dna[%d..%d]=%a dna'[%d..%d]=%a@." 
    start stop print (l) 
    start stop print (l')

let () = 
  let c0,t0 = pop dna in
  let c7 = get dna ~i:7 in
  let c6 = get t0 ~i:6 in
  printf "%a %a %a@." print_base c0 print_base c7 print_base c6;
  let t7 = skip dna ~i:7 in
  printf "%a@." print_base (fst (pop t7));
  let t8 = append (of_list [I;C]) (append (of_list [F;P]) t7) in
  for i = 0 to 10 do
    printf "t8[%d] = %a@." i print_base (get t8 ~i)
  done;
  (* sub tests *)
  let dna' =  append (of_list [I;I]) 
    (append (of_list [P;I;F]) (skip dna ~i:5)) in
  compare_sub 
    dna dna' (int_of_string Sys.argv.(1)) (int_of_string Sys.argv.(2));
  let t = sub dna' 1 200 in
  let l = to_list t in 
  assert (to_list (of_list l) = l)

